/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 189 by dpavlin, Tue Mar 16 23:05:31 2010 UTC revision 243 by dpavlin, Thu Mar 24 16:40:46 2011 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                  boot="    "                  boot="-"
59                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                  echo "$name $status $boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61          done          done ) | column -t
62  }  }
63    
64    
# Line 50  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
76    
77            echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79  }  }
80    
81    
# Line 64  setup_inittab() { Line 86  setup_inittab() {
86    
87          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
88          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
89          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
91                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
92                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 102  lxc_stop() { Line 124  lxc_stop() {
124    
125  lxc_start() {  lxc_start() {
126          name=$1          name=$1
127            rootfs=$(lxc_rootfs $1)
128    
129            if [ ! -e $rootfs ] ; then
130                    echo "ERROR $name rootfs $rootfs not found"
131                    return
132            fi
133    
134          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
135                  lxc_log "$name start"                  lxc_log "$name start"
136                    mount $rootfs -o remount,rw # fix debian upgrade which remounts dir ro
137                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
138                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
139                  lxc-info  -n $name                  lxc-info  -n $name
# Line 119  rootfs=$(lxc_rootfs $1) Line 148  rootfs=$(lxc_rootfs $1)
148  while true; do  while true; do
149          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
150          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
151            stop_on=1 # init
152            sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
153            if [ "$sulogins" -gt 0 ] ; then
154                    stop_on=`expr $stop_on + $sulogins`
155            fi
156    
157          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
158          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
159    
160                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
161                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
# Line 148  while true; do Line 183  while true; do
183                  ;;                  ;;
184                  esac                  esac
185          else          else
186                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
187          fi          fi
188    
189          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
# Line 160  lxc_log "$name watchdog exited" Line 195  lxc_log "$name watchdog exited"
195  }  }
196    
197    
198    usage() {
199            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
200            exit 3
201    }
202    
203  command_on_lxc() {  command_on_lxc() {
204  command=$1  command=$1
205  shift  shift
# Line 171  case "$command" in Line 211  case "$command" in
211  start)  start)
212          lxc_exists $1          lxc_exists $1
213          cleanup_init_scripts $1          cleanup_init_scripts $1
214          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
215          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
216            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
217          lxc_start $1          lxc_start $1
218          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
219          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 194  disable) Line 235  disable)
235          echo -n > /var/lib/lxc/$1/on_boot          echo -n > /var/lib/lxc/$1/on_boot
236          ;;          ;;
237  *)  *)
238          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
239          ;;          ;;
240    
241  esac  esac
# Line 203  esac Line 243  esac
243  }  }
244    
245  command=$1  command=$1
246  shift  test -z "$command" && usage
   
247  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
248    shift
249    
250  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
251          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do

Legend:
Removed from v.189  
changed lines
  Added in v.243

  ViewVC Help
Powered by ViewVC 1.1.26